/* de11d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__11 = 11;

/* Subroutine */ int de11d_c(S_fp f, integer *m, doublereal *xn,
        doublereal *yn, doublereal *xk, doublereal *hmin, doublereal *eps,
        doublereal *p, doublereal *h__, doublereal *y, doublereal *yp,
        doublereal *delty, doublereal *rab, integer *ierr)
{
    /* Initialized data */

    static doublereal l[2] = { 0.,1. };
    static doublereal n = .5;
    static doublereal o = .5;

    /* System generated locals */
    integer rab_dim1, rab_offset, i__1;
    doublereal d__1;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static logical a;
    static doublereal b, c__;
    static integer e;
    static doublereal w, x, z__;
    extern /* Subroutine */ int utde11_c(integer *, integer *);
    static integer ba;
    static logical bb;
    static doublereal bd, bg;
    static logical bul;

#define rab_ref(a_1,a_2) rab[(a_2)*rab_dim1 + a_1]

    /* Parameter adjustments */
    rab_dim1 = *m;
    rab_offset = 1 + rab_dim1 * 1;
    rab -= rab_offset;
    --delty;
    --yp;
    --y;
    --yn;

    /* Function Body */
    *ierr = 0;
    b = 8.;
    c__ = *xn;
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        y[e] = yn[e];
/* L1: */
    }
    if (*xn == *xk) {
        goto L23;
    }
    a = FALSE_;
    bul = FALSE_;
    d__1 = *xk - *xn;
    *h__ = d_sign(h__, &d__1);

L2:
    if (! a) {
        goto L3;
    }
    *h__ = w;

    goto L23;
L3:
    x = *xk - c__;
    if (abs(x) > abs(*h__)) {
        goto L4;
    }
    w = *h__;
    a = TRUE_;
    *h__ = x;
L4:
    z__ = c__;
    ba = 1;
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        yp[e] = y[e];
/* L5: */
    }
    goto L11;
L6:
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        delty[e] = y[e];
        y[e] = yp[e];
/* L7: */
    }
    c__ = z__;
    *h__ *= .5;
    ba = 2;
    goto L11;
L8:
    ba = 3;
    goto L11;
L9:
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        delty[e] = (y[e] - delty[e]) / 3.;
        y[e] += delty[e];
/* L10: */
    }
    *h__ *= 2.;
    goto L17;

L11:
    bg = c__;
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        rab_ref(e, 2) = y[e];
/* L12: */
    }
    (*f)(&c__, &rab_ref(1, 2), &rab_ref(1, 1), m);
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        rab_ref(e, 1) = rab_ref(e, 1) * *h__;
/* L13: */
    }
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        rab_ref(e, 2) = y[e] + n * rab_ref(e, 1);
/* L14: */
    }
    c__ = bg + o * *h__;
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        y[e] += l[0] * rab_ref(e, 1);
/* L15: */
    }
    (*f)(&c__, &rab_ref(1, 2), &rab_ref(1, 1), m);
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        y[e] += l[1] * rab_ref(e, 1) * *h__;
/* L16: */
    }
    c__ = bg + *h__;
    switch (ba) {
        case 1:  goto L6;
        case 2:  goto L8;
        case 3:  goto L9;
    }
L17:
    bb = TRUE_;
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        bd = (d__1 = y[e], abs(d__1));
        if (bd < *p) {
            goto L18;
        }
        delty[e] /= y[e];
L18:
        ;
    }
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        bd = (d__1 = delty[e], abs(d__1));
        if (bd > *eps) {
            goto L20;
        }
        if (! bb) {
            goto L19;
        }
        if (b * bd < *eps) {
            goto L19;
        }
        bb = FALSE_;
L19:
        ;
    }
    if (! bb) {
        goto L2;
    }
    *h__ += *h__;
    bul = FALSE_;
    goto L2;
L20:
    i__1 = *m;
    for (e = 1; e <= i__1; ++e) {
        y[e] = yp[e];
/* L21: */
    }
    if (bul) {
        goto L22;
    }
    c__ -= *h__;
    *h__ *= .5;
    a = FALSE_;
    if (abs(*h__) >= *hmin) {
        goto L4;
    }
    *h__ = d_sign(hmin, h__);
    bul = TRUE_;
    goto L4;
L22:
    *ierr = 65;
    utde11_c(ierr, &c__11);
L23:
    return 0;
} /* de11d_c */

#undef rab_ref
